polybori::PolynomialFactory Class Reference

This base class PolynomialFactory is used for currying polynomial constructors with a BoolePolyRing. More...

`#include <PolynomialFactory.h>`

Inheritance diagram for polybori::PolynomialFactory:

## Public Types

typedef base::parent_type | parent_type
| Type of parent. More...
typedef BoolePolynomial | value_type
| We construct element of this type. More...
Public Types inherited from polybori::CFactoryBase
typedef BoolePolyRing | parent_type
| Type of parent. More...

## Public Member Functions

| PolynomialFactory (const parent_type &ring)
| Construct from given ring. More...
| PolynomialFactory (const self &rhs)
| Copy constructor. More...
| ~PolynomialFactory ()
| Destructor. More...
value_type | operator() () const
| Get zero polynomial of the ring. More...
value_type | operator() (const value_type &rhs) const
| Indirect copy constructor. More...
value_type | operator() (const value_type::ring_type &ring) const
| Get first variable of explicit ring. More...
value_type | operator() (const value_type::var_type &var) const
| Construct from Boolean variable (does not need ring) More...
value_type | operator() (const value_type::monom_type &monom) const
| Construct from Boolean monomial (does not need ring) More...
value_type | operator() (const value_type::exp_type &rhs) const
| Construct from exponent vector. More...
value_type | operator() (const value_type::exp_type &rhs, const value_type::ring_type &ring) const
| Construct from exponent vector and explicit ring. More...
value_type | operator() (value_type::constant_type isOne, const value_type::ring_type &ring) const
| Construct polynomial from a constant value 0 or 1 and explicit ring. More...
value_type | operator() (value_type::constant_type isOne) const
| Construct polynomial from a constant value 0 or 1. More...
value_type | operator() (const value_type::dd_type &rhs) const
| Construct polynomial from decision diagram. More...
value_type | operator() (const value_type::navigator &rhs, const value_type::ring_type &ring) const
| Construct polynomial from navigator and explicit ring. More...
value_type | operator() (const value_type::navigator &rhs) const
| Construct polynomial from navigator. More...
Public Member Functions inherited from polybori::CFactoryBase
| CFactoryBase (const parent_type &parent)
| Default constructor. More...
| CFactoryBase (const self &rhs)
| Copy constructor. More...
| ~CFactoryBase ()
| Destructor. More...
const parent_type & | parent () const
| Access delayed data. More...

## Detailed Description

This base class PolynomialFactory is used for currying polynomial constructors with a BoolePolyRing.

## Member Typedef Documentation

typedef base::parent_type polybori::PolynomialFactory::parent_type

Type of parent.

typedef BoolePolynomial polybori::PolynomialFactory::value_type

We construct element of this type.

## Constructor & Destructor Documentation

polybori::PolynomialFactory::PolynomialFactory | ( | const parent_type & | ring | ) |

inline

Construct from given ring.

polybori::PolynomialFactory::PolynomialFactory | ( | const self & | rhs | ) |

inline

Copy constructor.

polybori::PolynomialFactory::~PolynomialFactory | ( |  | ) |

inline

Destructor.

## Member Function Documentation

value_type polybori::PolynomialFactory::operator() | ( |  | ) | const

inline

Get zero polynomial of the ring.

value_type polybori::PolynomialFactory::operator() | ( | const value_type & | rhs | ) | const

inline

Indirect copy constructor.

value_type polybori::PolynomialFactory::operator() | ( | const value_type::ring_type & | ring | ) | const

inline

Get first variable of explicit ring.

value_type polybori::PolynomialFactory::operator() | ( | const value_type::var_type & | var | ) | const

inline

Construct from Boolean variable (does not need ring)

value_type polybori::PolynomialFactory::operator() | ( | const value_type::monom_type & | monom | ) | const

inline

Construct from Boolean monomial (does not need ring)

value_type polybori::PolynomialFactory::operator() | ( | const value_type::exp_type & | rhs | ) | const

inline

Construct from exponent vector.

value_type polybori::PolynomialFactory::operator() | ( | const value_type::exp_type & | rhs,
|  | const value_type::ring_type & | ring
| ) |  | const

inline

Construct from exponent vector and explicit ring.

value_type polybori::PolynomialFactory::operator() | ( | value_type::constant_type | isOne,
|  | const value_type::ring_type & | ring
| ) |  | const

inline

Construct polynomial from a constant value 0 or 1 and explicit ring.

value_type polybori::PolynomialFactory::operator() | ( | value_type::constant_type | isOne | ) | const

inline

Construct polynomial from a constant value 0 or 1.

value_type polybori::PolynomialFactory::operator() | ( | const value_type::dd_type & | rhs | ) | const

inline

Construct polynomial from decision diagram.

value_type polybori::PolynomialFactory::operator() | ( | const value_type::navigator & | rhs,
|  | const value_type::ring_type & | ring
| ) |  | const

inline

Construct polynomial from navigator and explicit ring.

value_type polybori::PolynomialFactory::operator() | ( | const value_type::navigator & | rhs | ) | const

inline

Construct polynomial from navigator.

The documentation for this class was generated from the following file:

- PolynomialFactory.h